@ECHO OFF

echo -----------------------------------------------------------------------------
echo TS2MKV was made by Peach@CCTVB with tsMuxeR, eac3to and MediaInfo.
echo -----------------------------------------------------------------------------

REM Core Setting (DO NOT CHANGE IT)
set mkv2ts=%1
set outputfolder=%2
set ts=%3
set name=%4
set mkv2ts=%mkv2ts:"=%
set name=%name:"=%
set tsmuxer="%mkv2ts%\tools\tsMuxeR.exe"
set eac3to="%mkv2ts%\tools\eac3to.exe"
set mediainfo="%mkv2ts%\tools\MediaInfo.exe"
set metafile="%name%.meta"
set vid=30624700
set audcnt=30624770
set channel=0
set chname=Unknown
set "filemaska=*.ac3"
set "filemaskb=*.mkv"
set audio1=
set audio2=
set audio3=


REM Checking tsMuxeR Path
IF NOT EXIST %tsmuxer% (
	echo tsMuxeR path is incorrect!
	echo Current value: %tsmuxer%
	pause
	EXIT 4
)


REM Checking eac3to Path
IF NOT EXIST %eac3to% (
	echo eac3to path is incorrect!
	echo Current value: %eac3to%
	pause
	EXIT 4
)


REM Checking MediaInfo Path
IF NOT EXIST %mediainfo% (
	echo MediaInfo path is incorrect!
	echo Current value: %mediainfo%
	pause
	EXIT 4
)


REM Change Working Directory to Destination Folder
chdir /D %outputfolder%


echo -----------------------------------------------------------------------------
echo Getting Video info...
echo -----------------------------------------------------------------------------

%mediainfo% "--InForm=file://%mkv2ts%\tools\getvid.txt" %ts% > getvid.cmd
IF EXIST getvid.cmd (
	call getvid.cmd
) ELSE (
	echo -----------------------------------------------------------------------------
	echo Cannot create getvid.cmd. Getting Video ID failure...
	echo -----------------------------------------------------------------------------
	pause
	exit
)

%mediainfo% "--InForm=file://%mkv2ts%\tools\getaudcnt.txt" %ts% > getaudcnt.cmd
IF EXIST getaudcnt.cmd (
	call getaudcnt.cmd
) ELSE (
	echo -----------------------------------------------------------------------------
	echo Cannot create getaudcnt.cmd. Getting Audio Stream Count failure...
	echo -----------------------------------------------------------------------------
	pause
	exit
)

IF %vid% EQU 30624700 (
	echo -----------------------------------------------------------------------------
	echo Getting Video ID failure...
	echo -----------------------------------------------------------------------------
	pause
	exit
)

IF %audcnt% EQU 30624770 (
	echo -----------------------------------------------------------------------------
	echo Getting Audio Stream Count failure...
	echo -----------------------------------------------------------------------------
	pause
	exit
)

set /a channel=(%vid%-1)/10

IF %channel% EQU 85 set chname=HD Jade
IF %channel% EQU 84 set chname=Pearl
IF %channel% EQU 82 set chname=J2
IF %channel% EQU 81 set chname=Jade
IF %channel% EQU 83 set chname=iNews

echo -----------------------------------------------------------------------------
echo Channel %channel% %chname% detected.
echo -----------------------------------------------------------------------------

IF EXIST "%name%.track_%channel%*.ac3" (
	DEL /q "%name%.track_%channel%*.ac3"
)

REM Creating tsMuxeR metafile
echo MUXOPT --no-pcr-on-video-pid --new-audio-pes --demux --vbr  --vbv-len=500 > %metafile%
IF %audcnt% GTR 0 echo A_AC3, %ts%, track=%channel%2 >> %metafile%
IF %audcnt% GTR 1 echo A_AC3, %ts%, track=%channel%3 >> %metafile%
IF %audcnt% GTR 2 echo A_AC3, %ts%, track=%channel%4 >> %metafile%


echo -----------------------------------------------------------------------------
echo Demuxing Audio with tsMuxeR... Please wait a moment...
echo -----------------------------------------------------------------------------

REM Strating tsMuxeR
%tsmuxer% %metafile% %outputfolder%


REM Clear Empty File
for %%A in (%filemaska%) do if %%~zA==0 del /F /Q "%%A"


REM Check AC3
IF EXIST "%name%.track_%channel%*.ac3" (
	echo -----------------------------------------------------------------------------
	echo Demuxed Audio to AC3.
	echo -----------------------------------------------------------------------------
) ELSE (
	echo -----------------------------------------------------------------------------
	echo Demuxing Audio with tsMuxeR failure... Try to Demux Audio with eac3to...
	echo -----------------------------------------------------------------------------
	GOTO DEMUXAV
)


echo -----------------------------------------------------------------------------
echo Remuxing Video to mkv with eac3to... Please wait a moment...
echo -----------------------------------------------------------------------------

REM Strating eac3to
%eac3to% %ts% 1: "%name%.mkv"

REM Clear Empty File
for %%B in (%filemaskb%) do if %%~zB==0 del /F /Q "%%B"

GOTO END


:DEMUXAV

IF %audcnt% GTR 0 set audio1=2: "%name%.track_%channel%2.ac3"
IF %audcnt% GTR 1 set audio2=3: "%name%.track_%channel%3.ac3"
IF %audcnt% GTR 2 set audio3=4: "%name%.track_%channel%4.ac3"

echo -----------------------------------------------------------------------------
echo Demuxing Audio and Remuxing Video to mkv with eac3to... Please wait a moment...
echo -----------------------------------------------------------------------------

REM Strating eac3to
%eac3to% %ts% 1: "%name%.mkv" %audio1% %audio2% %audio3%

REM Clear Empty File
for %%A in (%filemaska%) do if %%~zA==0 del /F /Q "%%A"
for %%B in (%filemaskb%) do if %%~zB==0 del /F /Q "%%B"


REM Check AC3
IF EXIST "%name%.track_%channel%*.ac3" (
	echo -----------------------------------------------------------------------------
	echo Demuxed Audio to AC3.
	echo -----------------------------------------------------------------------------
) ELSE (
	echo -----------------------------------------------------------------------------
	echo Demuxing Audio and Remuxing Video failure...
	echo -----------------------------------------------------------------------------
	pause
	EXIT
)


:END

REM Finish
IF EXIST "%name%.mkv" (
	echo -----------------------------------------------------------------------------
	echo Remuxed Video to mkv, enjoy^^!
	echo -----------------------------------------------------------------------------
) ELSE (
	echo -----------------------------------------------------------------------------
	echo Demuxed to AC3 only, I can't remux video to mkv^^!
	echo -----------------------------------------------------------------------------
	pause
	exit
)